/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _ADVANCED_SELECTION_H_
#define _ADVANCED_SELECTION_H_

#include <gtkmm.h>
#include <vector>

class GridMazeFactory;

class AdvancedSelection: public Gtk::Dialog 
{
	private:
		Gtk::ComboBoxText mazetypes;
		std::vector<GridMazeFactory*> factories;
		void set_factory ();
		
		Glib::RefPtr<Gtk::HScale> sizescale, advanced_sizescale, ntrees, floatingtrees;
		void sizescale_value_changed ();
		void advanced_sizescale_value_changed ();		
		void ntrees_value_changed ();
		void ftrees_value_changed ();
		
		void trees_max_changed (int n);
		void trees_changed (int n);
		void floating_trees_max_changed (int n);
		void floating_trees_changed (int n);

	public:
		AdvancedSelection (BaseObjectType* cobj, const Glib::RefPtr<Gtk::Builder>& builder);
		~AdvancedSelection ();
		GridMazeFactory& get_factory () const { return *factories[mazetypes.get_active_row_number ()]; }
};

#endif // _ADVANCED_SELECTION_H_
