/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CASTLE_FACTORY_H_
#define _CASTLE_FACTORY_H_

#pragma interface

#include "grid-factory.h"

class CastleFactory: public GridMazeFactory
{
	public:
		CastleFactory ();
		virtual Glib::ustring get_name() const { return "Castle"; }
		virtual Glib::RefPtr<GridView> new_maze() const;
		
		virtual int get_min_trees() const;
		virtual int get_max_trees() const;
};

#endif // _CASTLE_FACTORY_H_
