/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CASTLE_MAZE_H_
#define _CASTLE_MAZE_H_

#pragma interface

#include "dungeon-maze-type.h"
#include <vector>

class CastleMaze: public DungeonMazeType
{
	private:
		xy entrance, exit;
		int inner_width, inner_height;
		
		Wall roomh, roomv, outer;
		void outer_wall ();
		void outer_wall_in_grid (std::vector<xy>& t);
		
		void towers (std::vector<xy>& t);
		void room_walls ();
		void room_walls_in_grid (std::vector<xy>& t);
		void mark_no_no ();

		int overlap_w, overlap_h;
		
	public:
		CastleMaze (int width, int height, int n_trees, int n_floating_trees);
		
		virtual xy get_entrance() const;
		virtual xy get_exit() const;
};



#endif // _CASTLE_MAZE_H_
