/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma implementation

#include "creta-view.h"
#include "grid-maze.h"
#include <list>

CretaView::CretaView (): PolarView () {
}

void CretaView::cline (Cairo::RefPtr<Cairo::Context> cr, int y, double r, PolarView::cline_type ltype) const {
	double dr = radius_for_x (r);
	double ag = angle_gap (dr);
	double a1 = (y - 1) * angle;
	double a2 = y * angle;

	switch (ltype) {
		case OPEN:
			a1 += ag;
			a2 -= ag;
			break;
		case CLOSED:
			a1 += ag;
			a2 += ag;
			break;
		default:
			break;
	}
	
	cr->arc (0, 0, dr, a1, a2);
	cr->stroke ();
}

ViewPtr CretaView::create () {
	return ViewPtr (new CretaView ());
}