/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DUNGEON_MAZE_H_
#define _DUNGEON_MAZE_H_

#pragma interface

#include "dungeon-maze-type.h"

class DungeonMaze: public DungeonMazeType
{
	private:
		xy entrance, exit;

	public:
		DungeonMaze (int width, int height, int n_trees, int n_floating_trees);

		virtual xy get_entrance() const;
		virtual xy get_exit() const;
};

inline int __dm_get_cc (int c) {
	int cc = c / 3;
	if ((cc & 1) == 0)
		cc -= 1;
	return cc;
}

#endif // _DUNGEON_H_
