/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DUNGEON_TYPE_VIEW_H_
#define _DUNGEON_TYPE_VIEW_H_

#pragma interface

#include <gtkmm.h>
#include "grid-view.h"

class DungeonTypeView: public GridView 
{
	private:
		DungeonTypeView ();
		int width, height;
		double maze_x, maze_y;
			
	public:
		static ViewPtr create ();

		virtual void set_size (int width, int height);
		virtual void render (Cairo::RefPtr<Cairo::Context> cr, Artwork::Renderer& renderer);
		virtual void render_solution (Cairo::RefPtr<Cairo::Context> cr, Artwork::Renderer& renderer);		
};

#endif // _DUNGEON_VIEW_H_
