/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _EXPORT_DIALOG_H_
#define _EXPORT_DIALOG_H_

#pragma interface

#include <gtkmm.h>
#include <map>

class GridView;
class ExportHandler;

class ExportDialog: public Gtk::FileChooserDialog 
{
	public:
		ExportDialog (BaseObjectType* cobj, const Glib::RefPtr<Gtk::Builder>& builder);
		void save (Glib::RefPtr<GridView> maze_view, int w, int h);

	private:
		Gtk::ComboBoxText format_selector;
		void adjust_filter ();
		std::map<Glib::ustring,const ExportHandler*> handlers;
};

#endif // _EXPORT_DIALOG_H_
