/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma implementation

#include "grid-view.h"
#include "export-handler.h"

using namespace Glib;
using namespace Gtk;
using namespace Gio;
using namespace Cairo;

ExportHandler::ExportHandler (const ustring& desc) {
	this->desc = desc;
}

Surface::SlotWriteFunc ExportHandler::get_writefunc (const FOS& fos) const {
	return bind (mem_fun (this, &ExportHandler::do_dump), fos);
}

ErrorStatus ExportHandler::do_dump (const unsigned char* buffer, int len, FOS fos) const {
	gsize written;

	bool r = fos->write_all ((const void*) buffer, (gsize) len, written);
	if (r && written == (gsize) len)
		return CAIRO_STATUS_SUCCESS;
	else
		return CAIRO_STATUS_WRITE_ERROR;			
}
