/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _EXPORT_HANDLER_H_
#define _EXPORT_HANDLER_H_

#pragma interface

#include <gtkmm.h>

class GridView;
typedef Glib::RefPtr<Gio::FileOutputStream> FOS;

class ExportHandler {
	private:
		Glib::ustring desc;

	protected:
		ExportHandler (const Glib::ustring& desc);
		Gtk::FileFilter filter;

		Cairo::Surface::SlotWriteFunc get_writefunc (const FOS& fos) const;
		Cairo::ErrorStatus do_dump (const unsigned char* buffer, int len, FOS fos) const;
		
	public:
		const Glib::ustring& get_description () const { return desc; }
		const Gtk::FileFilter& get_filter () const { return filter; }

		virtual void dump (Glib::RefPtr<GridView> maze_view, int w, int h, FOS fos) const = 0;
};

#endif // _EXPORT_HANDLER_H_
