/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma implementation

#include "export-pdf.h"
#include "grid-view.h"

using namespace Cairo;

ExportPDF::ExportPDF (): ExportHandler ("Adobe PDF Document") {
	filter.add_pattern ("*.pdf");
}

void ExportPDF::dump (ViewPtr maze_view, int w, int h, FOS fos) const {
	Surface::SlotWriteFunc swf = get_writefunc (fos);
	Cairo::RefPtr<Surface> surface = PdfSurface::create_for_stream (swf, w, h);
	Cairo::RefPtr<Context> cr = Context::create (surface);
	maze_view->render (cr, Artwork::render ());
}
