/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GRID_VIEW_H_
#define _GRID_VIEW_H_

#pragma interface

#include <gtkmm.h>
#include "artwork.h"

class GridMaze;
class GridView: public Glib::Object
{
	public:
		static Glib::RefPtr<GridView> create ();		

		virtual void set_maze (Glib::RefPtr<GridMaze> maze);
		virtual void set_size (int width, int height);
		bool has_changed () const { return changed; }
		void force_redraw () { changed = true; }
		virtual void render (Cairo::RefPtr<Cairo::Context> cr, Artwork::Renderer& renderer);
		virtual void render_solution (Cairo::RefPtr<Cairo::Context> cr, Artwork::Renderer& renderer);

	private:
		int width, height;
		void calculate_zfact ();
		bool changed;
		
	protected:
		double zfact;
		Artwork::art_handle a_handle;
		
		GridView ();
		Glib::RefPtr<GridMaze> maze;
};

typedef Glib::RefPtr<GridView> ViewPtr;

#endif // _GRID_VIEW_H_
