/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <iostream>
#include "mainwindow.h"
#include "util.h"
#include "artwork.h"

using namespace std;
using namespace Glib;
using namespace Gtk;

int main (int argc, char* argv[]) {
    try {
		Main app (argc, argv);
		Artwork::init ();
		
		RefPtr<Builder> builder = Builder::create_from_file (Resources::get_ui_path ());
		
		MainWindow* mainwindow;
		builder->get_widget_derived ("mainwindow", mainwindow);
		app.run(*mainwindow);
    }
    catch (const FileError& ex) {
        cerr << "Cannot load file: " << ex.what () << endl;
        return EXIT_FAILURE;
    }
    catch (const BuilderError& ex) {
        cerr << "Parse error in UI file: " << ex.what () << endl;
        return EXIT_FAILURE;
    }
	catch (const Error& ex) {
		cerr << "Fatal error: " << ex.what () << endl;
		return EXIT_FAILURE;
	}
    return EXIT_SUCCESS;
}
