/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MAINWINDOW_H_
#define _MAINWINDOW_H_

#pragma interface

#include <gtkmm.h>
#include <deque>

class AdvancedSelection;
class GridMaze;
class GridMazeFactory;
class GridView;
class ExportDialog;

class MainWindow: public Gtk::Window
{
	public:
		MainWindow (BaseObjectType* cobj, const Glib::RefPtr<Gtk::Builder>& builder);

	private:
		Glib::RefPtr<Gtk::ToggleAction> showsolution;
		Glib::RefPtr<Gtk::ToggleAction> showadvanced;
		Glib::RefPtr<Gtk::AboutDialog> aboutmazen;
		void on_about () const;

		int view_width, view_height;
		Glib::RefPtr<Gtk::DrawingArea> drawingarea;
		bool on_maze_redraw (GdkEventExpose* event);

		Glib::RefPtr<Gtk::Action> previous;
		void forward ();
		void back ();

		std::deque<Glib::RefPtr<GridView> > maze_history;
		std::deque<Glib::RefPtr<GridView> >::const_iterator current_view;
		
		Cairo::RefPtr<Cairo::Pattern> maze_pattern, sol_pattern;
		void print () const;

		Glib::RefPtr<AdvancedSelection> advanced;
		void create ();

		Glib::RefPtr<ExportDialog> exportdialog;
		void save () const;
};

#endif // _MAINWINDOW_H_
