/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _POLYGON_MAZE_H_
#define _POLYGON_MAZE_H_

#pragma interface

#include "grid-maze.h"

class PolygonMaze: public GridMaze 
{
	protected:
		virtual void solve ();
		virtual void possible_directions (xy pos, std::vector<Direction>& dirs) const;
		virtual void move (xy& pos, Direction dir);
		
	public:
		PolygonMaze (int size, int faces, int n_trees,  int n_floating_trees);

		virtual xy get_entrance() const;
		virtual xy get_exit() const;
};

#endif // _POLYGON_MAZE_H_
