/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma implementation

#include "traversal-factory.h"
#include "traversal-maze.h"
#include "traversal-view.h"

TraversalMazeFactory::TraversalMazeFactory (): GridMazeFactory (10, 4, 0) {
}

ViewPtr TraversalMazeFactory::new_maze () const {
	ViewPtr vp = TraversalView::create ();
	vp->set_maze (MazePtr (new TraversalMaze (size, size, n_trees, n_floating_trees)));
	return vp;
}

int TraversalMazeFactory::get_min_trees () const { return 2; }
int TraversalMazeFactory::get_max_trees () const { return 4 * size - 8; }

