/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma implementation

#include "tree.h"

Tree::Tree (GridMaze& m, const xy& p): maze (m), pos (p) {
}

bool Tree::move () {
	possible_moves.clear ();
	maze.possible_directions (pos, possible_moves);
	if (possible_moves.empty ())
		return backtrack ();
	else {
		GridMaze::Direction m = possible_moves[g_random_int_range (0, possible_moves.size ())];
		path.push (pos);
		maze.move (pos, m);
		return true;
	}
}

bool Tree::backtrack () {
	if (path.empty ())
		return false;
	else {
		pos.x = path.top ().x;
		pos.y = path.top ().y;
		path.pop ();
		return move ();
	}
}

