/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mazen-ng
 * Copyright (C) Jacob Zimmermann 2009 <jacob@jzimm.net>
 * 
 * mazen-ng is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mazen-ng is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _WALKER_H_
#define _WALKER_H_

#pragma interface

#include <list>
#include "grid-maze.h"

class Walker {
	protected:
		const GridMaze& maze;
		int* mat;
		int g_mat (const xy& p) const { return mat[p.y * maze.width () + p.x]; }
		void s_mat (const xy& p, int v) { mat[p.y * maze.width () + p.x] = v; }

	public:
		Walker (const GridMaze& maze);
		~Walker ();
		virtual void map (xy starting_position, int accum) = 0;
		virtual void gen_solution (std::list<xy>& s) const = 0;
};

#endif // _WALKER_H_
